﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr267_1
{
    // Обобщенный делегат с ограничением
    // на обобщенный параметр:
    delegate T MD<T>(T[] arg) 
    where T : struct;
    // Главный класс: 
    class Program
    {
        // Статический обобщенный метод с ограничением на 
            // обобщенный параметр: 
            static T First<T>(T[] t) where T: struct{ 
                return t[0]; 
            }
        // Статический обобщенный метод (без ограничений на 
        // обобщенный параметр): 
        static T Last<T>(T[] t){ 
            return t[t.Length - 1];
        }
        // Обычный (не обобщенный) статический метод: 
        static int MaxVal(int[] a){ 
            int val = a[0];
            for(int k = 1; k < a.Length; k++) {
                if(val < a[k]) val = a[k];
            }
            return val;
        }
        // Главный метод:
        static void Main()
        {
            // Создание экземпляров делегата:
            MD<int> A = First<int>;
            MD<char> B = Last;
            MD<int> C = MaxVal;
            // Вызов экземпляров делегата: 
            int x = A(new int[]{10, 7, 3, 1}); 
            char y = B(new char[]{ 'A', 'C', 'F'}); 
            int z = C(new int[]{1, 7, 2, 5, 11, 9, 3, 6});
            // Проверка результата:
            Console.WriteLine("Значение: {0}, {1} и {2}", x, y, z);
            // Задержка:
            Console.ReadLine();
        }
    }
}
